10 ;EFT  VERSION 1.7C (COMBAT ROUTINES) AUGUST 9, 1981
20 ;
30 ;Page zero RAM
40 ;
50 ;These locations are for the mainline routines
60 ;
70 CHUNKX=$BE
80 CHUNKY=$BF
90 CORPS=$B4
0100  *=$C0
0110 MAPPTR *=*+2
0120 ARMY *=*+1
0130 UNITNO *=*+1
0140 DEFNDR *=*+1
0150 TEMPR *=*+1
0160 TEMPZ *=*+1
0170 ACCLO *=*+1
0180 ACCHI *=*+1
0190 TURN *=*+1
0200 LAT *=*+1
0210 LONG *=*+1
0220 RFR *=*+1
0230 TRNTYP *=*+1
0240 SQVAL *=*+1
0250 ;
0260 ;
0270 CONSOL=$D01F
0280 AUDF1=$D200
0290 AUDC1=$D201
0300 RANDOM=$D20A
0310 NMIEN=$D40E
0320 ;
0330 ;THESE VALUES ARE USED BY MAINLINE ROUTINE ONLY
0340 ;
0350 EARTH=$606
0360 TRNCOD=$62B
0370  *=$636
0380 SQX *=*+1 adjacent square
0390 SQY *=*+1
0400  *=$68E
0410 DELAY *=*+1
0420 HANDCP *=*+1
0430 TOTGS *=*+1
0440 TOTRS *=*+1
0450 OFR *=*+1
0460 HOMEDR *=*+1
0470 ZOC *=*+1
0480 TEMPQ *=*+1
0490 LLIM *=*+1
0500 VICTRY *=*+1
0510 ;
0520 ;declarations of routines in other modules
0530 ;
0540 INVERT=$4D26
0550 STALL=$7200
0560 TERR=$7240
0570 TERRB=$7246
0580 Y00=$72DE
0590 TERRTY=$7369
0600 DNUMBR=$7BB2
0610 JSTP=$799C
0620 DWORDS=$79C0
0630 SWITCH=$79EF
0640 DEFNC=$79B4
0650 OFFNC=$7BF6
0660 XINC=$7BF2
0670 YINC=$7BF1
0680 ;
0690  *=$5400
0700 CORPSX *=*+159 x-coords of all units (pixel frame)
0710 CORPSY *=*+159 y-coords of all units (pixel frame)
0720 MSTRNG *=*+159 muster strengths
0730 CSTRNG *=*+159 combat strengths
0740 SWAP *=*+159 terrain code underneath unit
0750 ARRIVE *=*+159 turn of arrival
0760 WORDS *=*+272 various words for messages
0770 CORPT *=*+159 codes for unit types
0780 CORPNO *=*+159 ID numbers of units
0790 HDIGIT *=*+256 tables for displaying numbers (hundreds)
0800 TDIGIT *=*+256 tens tables
0810 ODIGIT *=*+256 ones tables
0820 TXTTBL *=*+96 more text
0830 MONLEN *=*+13 table of month lengths
0840 HMORDS *=*+159 how many orders each unit has in queue
0850 WHORDS *=*+159 what the orders are
0860 WHORDH *=*+159
0870 BEEPTB *=*+4 table of beep tones
0880 ERRMSG *=*+128 table of error messages
0890 XOFF *=*+4 offsets for moving maltakreuze
0900 YOFF *=*+4
0910 MASKO *=*+4 mask values for decoding orders
0920 XADD *=*+4 offsets for moving arrow
0930 YADD *=*+4
0940 TRTAB *=*+13 tree color table
0950 MLTKRZ *=*+8 maltese cross shape
0960 ;
0970 ;RAM from $6000 to $6430 is taken up by
0980 ;character sets and the display list
0990 ;
1000  *=$6431
1010 ARRTAB *=*+32 arrow shapes
1020  *=$6450
1030 TXTWDW *=$6CB1
1040 STKTAB *=*+16 a joystick decoding table
1050 SSNCOD *=*+12 season codes
1060 TRNTAB *=*+60 terrain cost tables
1070 BHX1 *=*+22 intraversible square pair coordinates
1080 BHY1 *=*+22
1090 BHX2 *=*+22
1100 BHY2 *=*+22
1110 EXEC *=*+159 execution times
1120 ;
1130  *=$4ED8
1140 ;
1150 ;combat routine
1160 ;
1170  LDA #$00
1180  STA VICTRY clear victory flag
1190  LDX ARMY
1200  CPX #$2A Finns can't attack
1210  BEQ A10
1220  CPX #$2B
1230  BNE A11
1240 A10 RTS
1250 A11 LDY UNITNO
1260  STY DEFNDR
1270  LDX DEFNDR make combat graphics
1280  LDA SWAP,X
1290  PHA
1300  LDA #$FF solid red square
1310  CPX #$37 Russian unit?
1320  BCS B1
1330  LDA #$7F make it white for Germans
1340 B1 STA SWAP,X
1350  STX CORPS
1360  LDA CORPSX,X
1370  STA CHUNKX
1380  LDA CORPSY,X
1390  STA CHUNKY
1400  JSR SWITCH
1410  LDY #$08
1420  LDX #$8F
1430 LOOP78 STX AUDC1
1440  STY AUDF1
1450  JSR STALL
1460  TYA
1470  CLC
1480  ADC #$08
1490  TAY
1500  DEX
1510  CPX #$7F
1520  BNE LOOP78
1530 ;
1540 ;now replace original unit character
1550 ;
1560  JSR SWITCH
1570  LDX DEFNDR
1580  PLA
1590  STA SWAP,X
1600 ;
1610 ;
1620  JSR TERRTY terrain in defender's square
1630  LDX DEFNC,Y defensive bonus factor
1640  LDA CSTRNG,Y defender's strength
1650  LSR A
1660 Y15 DEX adjust for terrain
1670  BEQ Y16
1680  ROL A
1690  BCC Y15
1700  LDA #$FF
1710 ;
1720 ;now adjust for defender's motion
1730 ;
1740 Y16 LDX HMORDS,Y
1750  BEQ DOBATL
1760  LSR A
1770 ;
1780 ;evaluate defender's strike
1790 ;
1800 DOBATL CMP RANDOM
1810  BCC ATAKR
1820  LDX ARMY
1830  DEC MSTRNG,X
1840  LDA CSTRNG,X
1850  SBC #$05
1860  STA CSTRNG,X
1870  BEQ Z28
1880  BCS Y24
1890 Z28 JMP DEAD attacker dies
1900 Y24 JSR BRKCHK attacker lives; does he break?
1910 ;
1920 ;evaluate attacker's strike
1930 ;
1940 ATAKR LDX ARMY
1950  LDA CORPSX,X
1960  STA LONG
1970  LDA CORPSY,X
1980  STA LAT
1990  JSR TERR
2000  JSR TERRTY
2010  LDA OFFNC,Y
2020  TAY
2030  LDX ARMY
2040  LDA CSTRNG,X
2050  DEY
2060  BEQ Y19
2070  LSR A river attack penalty
2080 Y19 CMP RANDOM
2090  BCC A20
2100  LDX DEFNDR attacker strikes defender
2110  DEC MSTRNG,X
2120  LDA CSTRNG,X
2130  SBC #$05
2140  STA CSTRNG,X
2150  BEQ Z29
2160  BCS Y25
2170 Z29 JSR DEAD defender dies
2180 A20 JMP ENDCOM
2190 Y25 JSR BRKCHK does defender break?
2200  BCC A20
2210  LDY ARMY
2220  LDA WHORDS,Y
2230  AND #$03
2240  TAY first retreat priority : away from attacker
2250  JSR RETRET
2260  BCC VICCOM defender died
2270  BEQ Y27 defender may retreat
2280  LDY #$01 second priority: east/west
2290  CPX #$37
2300  BCS Y28
2310  LDY #$03
2320 Y28 JSR RETRET
2330  BCC VICCOM
2340  BEQ Y27
2350  LDY #$02 third priority: north
2360  JSR RETRET
2370  BCC VICCOM
2380  BEQ Y27
2390  LDY #$00 fourth priority: south
2400  JSR RETRET
2410  BCC VICCOM
2420  BEQ Y27
2430  LDY #$03 last priority: west/east
2440  CPX #$37
2450  BCS Y26
2460  LDY #$01
2470 Y26 JSR RETRET
2480  BCC VICCOM
2490  BNE ENDCOM
2500 Y27 STX CORPS retreat the defender
2510  LDA CORPSX,X
2520  STA CHUNKX
2530  LDA CORPSY,X
2540  STA CHUNKY
2550  JSR SWITCH
2560  LDX CORPS
2570  LDA LAT
2580  STA CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORPSY,X
2590  STA CHUNKY
2600  LDA LONG
2610  STA CORPSX,X
2620  STA CHUNKX
2630  JSR SWITCH
2640 VICCOM LDX ARMY
2650  STX CORP