INCLUDED4:EFT36I.ASM
;
;EFT VERSION 36S (SUBROUTINES) JANUARY 29, 1983
;
STALLALDA#30
STALLCLC
ADCRTCLKL
LOOP79CMPRTCLKL
BNELOOP79
RTS
;
;Subroutine TERR determines what terrain is in a square
;
TERRJSRTERRB
BEQLOOKUP
RTS
TERRBLDA#0
STAMAPPTR+1
STAUNITNO
LDA#$27
SEC
SBCLAT
ASLA
ROLMAPPTR+1
ASLA
ROLMAPPTR+1
ASLA
ROLMAPPTR+1
ASLA
ROLMAPPTR+1
STATLO
LDYMAPPTR+1
STYTHI
ASLA
ROLMAPPTR+1
CLC
ADCTLO
STAMAPPTR
LDAMAPPTR+1
ADCTHI
ADC#[MAPDAT+1]/256
STAMAPPTR+1
LDA#46
SEC
SBCLONG
TAY
LDA(MAPPTR),Y
STATRNCOD
AND#$3F
CMP#$3D
BEQA81
CMP#$3E
BEQA81
CMP#$3C
A81RTS
;
LOOKUPLDATRNCOD
STAUNTCOD
AND#$C0
LDX#NOUNTS
CMP#$40
BNEX98
LDX#NOGERM-1
X98LDALAT
LOOP30CMPCORPSY,X
BEQMIGHTB
X97DEX
BNELOOP30
LDA#$FF
STATXTWDW+128
BMIMATCH
MIGHTBLDALONG
CMPCORPSX,X
BNEX99
LDACSTRNG,X
BEQX99
LDAARRIVE,X
BMIX99
CMPTURN
BCCMATCH
BEQMATCH
X99LDALAT
JMPX97
MATCHSTXUNITNO
LDASWAP,X
STATRNCOD
RTS
;
SETLATLDACORPSX,X
STALONG
LDACORPSY,X
STALAT
RTS
;
;determines execution time of next move
;
DINGOLDXARMY
LDAHMORDS,X
BNEY00
LDA#$FF
STAEXEC,X
RTS
Y00JSRSETLAT
JSRTERR
LDAUNTCOD
STAUNTCD1
LDXARMY
JSRSETLAT
JSRFIGMOV
JSRTERR
JSRTERRTY
LDAUNTCD1
AND#$3F
LDX#0
CMP#$3D
BEQY01;infantry
LDX#$A;armor
Y01TXA
LDXMONTH
CLC
ADCSSNCOD-1,X;add season index
ADCTRNTYP;add terrain index
TAX
LDATRNTAB,X;get net delay
LDXARMY
LDYMODE,X
CPY#2
BNEZ32
LSRA
CLC
ADC#2
BNEY21
Z32CPY#1
BNEY21
STATEMPR
LSRA
CLC
ADCTEMPR
Y21CLC
ADCTICK
STAEXEC,X
LDATRNTYP
CMP#7
BCCY02
JSRCHKBHX
BNEY02
LDA#$FF
STAEXEC,X
Y02RTS
;
FIGMOVLDAWHORDS,X
AND#3
TAY
LDALONG
CLC
ADCXINC,Y
STALONG
LDALAT
CLC
ADCYINC,Y
STALAT
RTS
;
DIVIDELDY#8
LOOP35ASLPRODLO
ROLPRODHI
BCCY47
LDAPRODHI
SBCDIVISR
JMPY49
Y47LDAPRODHI
SEC
SBCDIVISR
BCCY50
Y49STAPRODHI
INCPRODLO
Y50DEY
BNELOOP35
RTS
;
SUBSQVSTATEMPR
LDASQVAL
SEC
SBCTEMPR
BCSZ35
LDA#0
Z35STASQVAL
RTS
;
WFRLSJSRGETCON
CMP#7
BNEWFRLS
JSRSTALLA
LOOP68JSRGETCON
CMP#7
BNELOOP68
RTS
;
ERR1JSRWDWCLR
LDAERRPTR,X
TAX
LDY#MSGPLC+4
LOOP28LDAERRMSG,X
SEC
SBC#$20
STATXTWDW,Y
INY
INX
CMP#1
BNELOOP28
RTS
;
DELRNGLDACORPSX,Y
SEC
SBCCORPSX,X
JSRINVERT
DELRG2STATEMPR
LDACORPSY,Y
SEC
SBCCORPSY,X
JSRINVERT
CLC
ADCTEMPR
RTS
;
TARGRGLDACORPSX,X
SEC
SBCTARGX
JSRINVERT
STATEMPR
LDACORPSY,X
SEC
SBCTARGY
JSRINVERT
CLC
ADCTEMPR
RTS
;
TXTMSGJSRWDWCLR
LDYTXTCNT,X
LDATXTLNG,X
TAX
LOOP19LDATXTTBL,X
SEC
SBC#$20
CMP#1
BEQZ68
STATXTWDW,Y
INY
INX
BNELOOP19
;
SETCHKSTXCORPS
LDACORPSX,X
STACHUNKX
LDACORPSY,X
STACHUNKY
Z68RTS
;
;combatroutine
;
COMBSTADEFNDR
LDA#0
STAVICTRY;clear victory flag
CPX#$1F;Finns can't attack
BEQA10
CPX#$20
BNEA11
A10RTS
A11JSRCHKAIR
LDXDEFNDR;make combat graphics
LDASWAP,X
PHA
LDA#$FF;solid red square
CPX#NOGERM;Russian unit?
BCSX46
LDA#$7F;make it white for Germans
X46STASWAP,X
JSRCALSWT
LDXARMY
JSRSETCHK
JSRCALPOS
LDA#$3C
STAPCOLR1
LDX#8
LOOP92LDABULLET,X
STABUFFER,X
LDACCTAB,X
STASCBUF,X
LDACFTAB,X
STASFBUF,X
DEX
BPLLOOP92
JSRMOVPLR
;
;now replace original unit character
;
LDXDEFNDR
JSRCALSWT
PLA
STASWAP,X
;
;
JSRCHKAIR
JSRTERRTY;terrain in defender's square
LDXDEFNC,Y;defensive bonus factor
LDALEVEL
CMP#4
BNEX04
INX
X04LDYDEFNDR
LDACSTRNG,Y;defender's strength
LSRA
Y15DEX;adjust for terrain
BEQY16
ROLA
BCCY15
LDA#$FF
;
;now adjust for defender's motion
;
Y16LDXHMORDS,Y
BEQDOBATL
LSRA
;
;evaluate defender's strike
;
DOBATLLDXMODE,Y
CPX#3
BNEY13
ASLA
BCSY05
Y13CPY#NOGERM
BCSY53
ADCAIRBST,Y
BCSY05
Y53CMPRANDOM
BCCATAKR
Y05LDXARMY
JSRKILL
BCSY24
RTS
Y24JSRBRKCHK;attacker lives; does he break?
BCCATAKR
JMPENDCOM
;
;evaluate attacker's strike
;
ATAKRLDXARMY
JSRSETLAT
JSRTERR
JSRTERRTY
LDAOFFNC,Y
TAY
LDXARMY
LDACSTRNG,X
DEY
BEQY19
LSRA;river attack penalty
Y19CPX#NOGERM
BCSY52
ADCAIRBST,X
BCSY18
Y52CMPRANDOM
BCCENDCOM
Y18LDXDEFNDR;attacker strikes defender
JSRKILL
BCCVICCOM
JSRBRKCHK;does defender break?
BCCENDCOM
LDYARMY
LDAWHORDS,Y
AND#3
TAY;first retreat priority : away from attacker
JSRRETRET
BCCVICCOM;defender died
BEQY27;defender may retreat
LDY#1;second priority: east/west
CPX#NOGERM
BCSY28
LDY#3
Y28JSRRETRET
BCCVICCOM
BEQY27
LDY#2;third priority: north
JSRRETRET
BCCVICCOM
BEQY27
LDY#0;fourth priority: south
JSRRETRET
BCCVICCOM
BEQY27
LDY#3;last priority: west/east
CPX#NOGERM
BCSY26
LDY#1
Y26JSRRETRET
BCCVICCOM
BNEENDCOM
;
Y27JSRSETCHK;retreat the defender
JSRSETSWH
VICCOMLDXARMY
JSRSETCHK
LDAACCLO;defender's coordinates
STALONG
LDAACCHI
STALAT
LDA#$FF
STAVICTRY
ENDCOMLDXARMY
INCEXEC,X
RTS
;
;Subroutines for combat
;input: X = ID # of defender. Y = proposed DIR of retreat
;output: C bit set if defender lives, clear if dies
;Z bit set if retreat open, clear if blocked
;
RETRETSTYDIR
JSRSETLAT
JSRFIGMOV+6
JSRTERR;examine terrain
JSRTERRTY
LDXDEFNDR
LDAUNITNO;anybody in this square?
BNEY22
LDATRNTYP;no
;
;check for bad ocean crossings
;
CMP#7;coastline?
BCCY41
CMP#9
BEQY22
JSRCHKBHX
BEQY22
;
;any blocking ZOC's?
;
Y41JSRCHKZOC
LDXDEFNDR
LDAZOC
CMP#2
BCSY22;no retreat into ZOC
CPX#NOFLIG
BCCZ58
CPX#NOGERM
BCCZ59
Z58LDA#0;retreat is possible
STAMODE,X
Z59SEC
RTS
Y22LDYLEVEL
JSRKILL2
RTS
;
CHKAIRCPX#NOGERM
BCSY38
CPX#NOFLIG
BCCY38
LSRCSTRNG,X
LSRCSTRNG,X
LDA#0
STAHMORDS,X
LDA#$FF
STAEXEC,X
Y38RTS
;
;subroutine KILL
;
KILLLDYARMY
LDAMODE,Y
CMP#1
BNEY14
LDY#0
CPXARMY
BEQY39
INY
BNEY39
Y14LDYLEVEL
Y39LDAMSTRNG,X
SEC
SBCMBLOOD,Y
STAMSTRNG,X
KILL2LDACSTRNG,X
SEC
SBCCBLOOD,Y
STACSTRNG,X
BEQZ27
BCSY23
Z27JSRDEAD
Y23RTS
;
;subroutine SETSWH
;
SETSWHJSRSWITCH
JSRCALPOS
BEQNOGRAF
LDY#$46
CPX#NOGERM
BCSZ04
LDY#$C
Z04STYPCOLR1
LDY#0
LDASWAP,X
ASLA
ASLA
ASLA
TAX
LOOP89LDACHRSET+256,X
STABUFFER,Y
LDAMFTAB,Y
STASFBUF,Y
LDAMCTAB,Y
STASCBUF,Y
INX
INY
CPY#9
BNELOOP89
JSRMOVPLR

NOGRAFLDXCORPS
LDALAT
STACORPSY,X
STACHUNKY
LDALONG
STACORPSX,X
STACHUNKX
JSRSWITCH
LDY#17
LOOPHLDACORPSX,X
CMPMOSCX,Y
BNEA18
LDACORPSY,X
CMPMOSCY,Y
BNEA18
LDA#$FF
CPX#NOGERM
BCCA19
LDA#0
A19STAMOSCOW,Y
AND#$80
EOR#$80
STATEMPR
LDASWAP,X
AND#$7F
ORATEMPR
STASWAP,X
A18DEY
BPLLOOPH
RTS
;
;subroutine CALPOS
;
CALPOSJSRCALCHK
JSRCALBAS
LDXCORPS
LDABASEX
SEC
SBC#$D0
LSRA
LSRA
LSRA
ORA#$E0
CLC
ADCCHUNKX
BCCZ22
CMPCORPSX,X
BEQZ22
BCSOUTPOS
;
Z22LDABASEX
SEC
SBC#$28
LSRA
LSRA
LSRA
CLC
ADCCHUNKX
CMPCORPSX,X
BCCOUTPOS
;
LDABASEY
SEC
SBC#$56
LSRA
LSRA
LSRA
ORA#$E0
CLC
ADCCHUNKY
BCCZ23
CMPCORPSY,X
BEQZ23
BCSOUTPOS
;
Z23LDABASEY
SEC
SBC#$F
LSRA
LSRA
LSRA
CLC
ADCCHUNKY
CMPCORPSY,X
BCCOUTPOS
;
LDACHUNKX
SEC
SBCCORPSX,X
ASLA
ASLA
ASLA
CLC
ADCBASEX
CMP#230
BCSOUTPOS
CMP#32
BCCOUTPOS
STAHPOS
DECHPOS
;
LDACHUNKY
SEC
SBCCORPSY,X
ASLA
ASLA
ASLA
CLC
ADCBASEY
CMP#$5F
BCSOUTPOS
CMP#$D
BCCOUTPOS
STAVPOS
RTS
OUTPOSLDA#0
STAVPOS
STAHPOS
RTS
;
MOVPLRLDX#$FF
STXTEMPD
BMIZ45
LOOP57LDYDIR
LOOP66DEX
BMIZ21
LDAVPOS
CLC
ADCYADD,Y
STAVPOS
LDAHPOS
CLC
ADCXADD,Y
STAHPOS
BNELOOP66
Z21INX
LDAYPOSL
LSRA
BCCZ30
LDX#$20
DECVPOS
Z30STXVDELAY
LDX#0
LDYVPOS
LOOP63CPY#$16
BCCZ11
CPY#$5F
BCSZ11
LDABUFFER,X
STAPLYR1,Y
Z11INY
INX
CPX#8
BNELOOP63
LDAHPOS
STAHPOSP1
;
Z45LDA#1
JSRSTALL
LDA#0
LDX#9
LDYVPOS
LOOP64STAPLYR1,Y
INY
DEX
BPLLOOP64
JSRCALPOS
INCTEMPD
LDXTEMPD
CPX#9
BEQZ53
LDASFBUF,X
STAAUDF1
LDASCBUF,X
STAAUDC1
JMPLOOP57
Z53LDA#$DC
STAPCOLR1
RTS
;
;subroutine CHKBHX
;
CHKBHXLDY#$15
LOOP42LDALAT
CMPBHY1,Y
BNEY43
LDALONG
CMPBHX1,Y
BNEY43
LDACORPSX,X
CMPBHX2,Y
BNEY43
LDACORPSY,X
CMPBHY2,Y
BEQX78
Y43DEY
BPLLOOP42
X78RTS
;
;supply evaluation routine
;
LOGSTCLDAARRIVE,X
CMPTURN
BEQZ86
BCCZ86
RTS
Z86CPX#NOGERM
BCSA13
LDYEARTH
CPY#2;mud?
BEQA12
CPY#$A;snow?
BNEA13
LDACORPSX,X;this discourages gung-ho corps
ASLA;double distance
ASLA
ADC#$4A
CMPRANDOM
BCCA12
LDA#$10;harder to get supplies in winter
A13LDY#1;Russians go east
CPX#NOGERM
BCSZ80
LDY#3;Germans go west
Z80STYHOMEDR
JSRSETLAT
LDA#0
STARFR
LOOP91LDALONG
STATEMPX
LDALAT
STATEMPY
LOOP90LDATEMPX
CLC
ADCXINC,Y
STALONG
LDATEMPY
CLC
ADCYINC,Y
STALAT
JSRCHKZOC
CPX#NOGERM
BCCA80
JSRTERRB
LDATRNCOD
CMP#$BF
BEQA77
A80LDAZOC
CMP#2
BCCZ81
INCRFR
A77INCRFR
LDARFR
CMP#$18
BCCZ84
A12LSRCSTRNG,X
BNEA50
JMPDEAD
Z84LDARANDOM
AND#2
TAY
BPLLOOP90
Z81LDYHOMEDR
LDALONG
CPY#1
BNEZ85
CMP#$FF
BNELOOP91
A50RTS
Z85CMP#$2E
BNELOOP91
RTS
;
;routine to check for zone of control
;
CHKZOCLDA#0
STAZOC
LDA#$40
CPX#NOGERM
BCSA70
LDA#$C0
A70STATEMPR
JSRTERRB
BNEA74
LDATRNCOD
AND#$C0
CMPTEMPR
BEQA71
LDACORPSX,X
CMPLONG
BNEA79
LDACORPSY,X
CMPLAT
BEQA74
A79RTS
A71LDA#2
STAZOC
RTS
A74LDALEVEL
CMP#2
BCCA79
LDX#7
LOOPQLDYJSTP+16,X
JSRFIGMOV+6
JSRTERRB
BNEA75
LDATRNCOD
AND#$C0
CMPTEMPR
BNEA75
TXA
AND#1
CLC
ADC#1
ADCZOC
STAZOC
A75DEX
BPLLOOPQ
DECLAT
DECLONG
LDXARMY
RTS
;
DEADJSRCALSWT
STXTEMPHI
LDY#3
LOOP69STYTEMPLO
JSRSETLAT
JSRFIGMOV+6
JSRTERR
LDXTEMPHI
LDYUNITNO
BEQZ90
CPX#NOGERM
BCCFOOLDU
CPY#NOGERM
BCSZ76
BCCZ90
FOOLDUCPY#NOGERM
BCCZ76
Z90LDYTEMPLO
DEY
BPLLOOP69
BMIZ08
Z76LDAMSTRNG,X
LSRA
LSRA
CLC
ADCMSTRNG,Y
BCCZ09
LDA#$FF
Z09STAMSTRNG,Y
BNEZ90
;
Z08LDA#0
STAMSTRNG,X
STACSTRNG,X
STAHMORDS,X
LDA#$FF
STAEXEC,X
LDATURN
CLC
ADC#$80
STAARRIVE,X
RTS
;
;Subroutine BRKCHK evaluates whether a unit under attack breaks
;
BRKCHKLDYLEVEL
CPY#2
BCSZ82
LDAMSTRNG,X
LSRA
LSRA
JMPY70
Z82CPX#NOGERM
BCSWEAKLG
LDACORPT,X
AND#$F0
BNEWEAKLG
LDAMSTRNG,X
LSRA
BPLY40
WEAKLGLDAMSTRNG,X
LSRA
LSRA
LSRA
STATEMPR
LDAMSTRNG,X
SEC
SBCTEMPR
Y40LDYMODE,X
BEQY70
CPY#2
BNEY83
ASLA
BCCY70
LDA#$FF
BCSY70
Y83LSRA
Y70CMPCSTRNG,X
BCCA30
LDA#$FF
STAEXEC,X
LDA#0
STAHMORDS,X
A30RTS
;
DECODEDB$FF,127,191,0
;
STEP1INCMAPLO
BNEZ67
INCMAPHI
Z67RTS
;
STEP2STA(MAPPTR),Y
INCMAPPTR
BNEZ75
INCMAPPTR+1
Z75RTS
