10 ;EFT  VERSION 1.7M (MAINLINE ROUTINES) AUGUST 9, 1981
20 ;
30 ;Page zero RAM
40  *=$B0
50 ;
60 ;These locations are used by the interrupt service routine
70 ;
80 DLSTPT *=*+2 Zero page pointer to display list
90 MAPLO *=*+1
0100 MAPHI *=*+1
0110 CORPS *=*+1 number of unit under window
0120 CURSXL *=*+1
0130 CURSXH *=*+1
0140 CURSYL *=*+1 cursor coordinates on screen (map frame)
0150 CURSYH *=*+1
0160 OFFLO *=*+1 How far to offset new LMS value
0170 OFFHI *=*+1
0180 TEMPI *=*+1 An all-purpose temporary register
0190 CNT1 *=*+1 DLI counter
0200 CNT2 *=*+1 DLI counter for movable map DLI
0210 CHUNKX *=*+1 cursor coordinates (pixel frame)
0220 CHUNKY *=*+1
0230 ;
0240 ;These locations are for the mainline routines
0250 ;
0260 MAPPTR *=*+2
0270 ARMY *=*+1
0280 UNITNO *=*+1
0290 DEFNDR *=*+1
0300 TEMPR *=*+1
0310 TEMPZ *=*+1
0320 ACCLO *=*+1
0330 ACCHI *=*+1
0340 TURN *=*+1
0350 LAT *=*+1
0360 LONG *=*+1
0370 RFR *=*+1
0380 TRNTYP *=*+1
0390 SQVAL *=*+1
0400 ;
0410 ;OS locations (see OS manual)
0420 ;
0430 SDMCTL=$022F
0440 DLSTLO=$0230 Existing OS pointer to display list
0450 DLSTHI=$0231
0460 GPRIOR=$026F
0470 PCOLR0=$02C0
0480 PCOLR1=$02C1
0490 PCOLR2=$02C2
0500 PCOLR3=$02C3
0510 COLOR0=$02C4
0520 COLOR1=$02C5
0530 COLOR4=$02C8
0540 CHBAS=$02F4
0550 ;
0560 ;HARDWARE LOCATIONS
0570 ;
0580 HPOSP0=$D000
0590 SIZEP0=$D008
0600 SIZEP1=$D009
0610 TRIG0=$D010
0620 COLPF0=$D016
0630 COLPF1=$D017
0640 COLPF2=$D018
0650 COLPF3=$D019
0660 COLBAK=$D01A
0670 GRACTL=$D01D
0680 RANDOM=$D20A
0690 HSCROL=$D404
0700 VSCROL=$D405
0710 PMBASE=$D407
0720 NMIEN=$D40E
0730 SETVBV=$E45C
0740 XITVBV=$E462
0750 ;
0760 ;Page 6 usage
0770 ;
0780  *=$0600
0790 ;first come locations used by the interrupt service routine
0800 XPOSL *=*+1 Horizontal position of
0810 YPOSL *=*+1 Vertical position of
0820 YPOSH *=*+1 upper left corner of screen window
0830 SCY *=*+1 vert position of cursor (player frame)
0840 SHPOS0 *=*+1 shadows player 0 position
0850 TRCOLR *=*+1
0860 EARTH *=*+1
0870 ICELAT *=*+1
0880 SEASN1 *=*+1
0890 SEASN2 *=*+1
0900 SEASN3 *=*+1
0910 DAY *=*+1
0920 MONTH *=*+1
0930 YEAR *=*+1
0940 BUTFLG *=*+1
0950 BUTMSK *=*+1
0960 TYL *=*+1
0970 TYH *=*+1
0980 DELAY *=*+1 acceleration delay on scrolling
0990 TIMSCL *=*+1 frame to scroll in
1000 TEMPLO *=*+1 temporary
1010 TEMPHI *=*+1
1020 BASEX *=*+1 starting position for arrow (player frame)
1030 BASEY *=*+1
1040 STEPX *=*+1 intermediate position of arrow
1050 STEPY *=*+1
1060 STPCNT *=*+1 which intermediate steps arrow is on
1070 ORDCNT *=*+1 which order arrow is showing
1080 ORD1 *=*+1 orders record
1090 ORD2 *=*+1
1100 ARRNDX *=*+1 arrow index
1110 HOWMNY *=*+1 how many orders for unit under cursor
1120 KRZX *=*+1 maltakreuze coords (player frame)
1130 KRZY *=*+1
1140 DBTIMR *=*+1 joystick debounce timer
1150 STICKI *=*+1
1160 ERRFLG *=*+1
1170 KRZFLG *=*+1
1180 STKFLG *=*+1
1190 HITFLG *=*+1
1200 TXL *=*+1 temporary values---slightly shifted
1210 TXH *=*+1
1220 ;
1230 ;THESE VALUES ARE USED BY MAINLINE ROUTINE ONLY
1240 ;
1250 OLDLAT *=*+1
1260 TRNCOD *=*+1
1270 TLO *=*+1
1280 THI *=*+1
1290 TICK *=*+1
1300 UNTCOD *=*+1
1310 UNTCD1 *=*+1
1320 ;
1330 HANDCP=$68F
1340 ZOC=$694
1350 VICTRY=$697
1360 ;
1370 ;declarations of routines in other modules
1380 ;
1390 CHKZOC=$5140
1400 LOGSTC=$5091
1410 DNUMBR=$7BB2
1420 DWORDS=$79C0
1430 SWITCH=$79EF
1440 YINC=$7BF1
1450 XINC=$7BF2
1460 ;
1470  *=$5200
1480 PLYR0 *=*+128
1490 PLYR1 *=*+128
1500 PLYR2 *=*+128
1510 PLYR3 *=*+128 currently unused
1520 CORPSX *=*+159 x-coords of all units (pixel frame)
1530 CORPSY *=*+159 y-coords of all units (pixel frame)
1540 MSTRNG *=*+159 muster strengths
1550 CSTRNG *=*+159 combat strengths
1560 SWAP *=*+159 terrain code underneath unit
1570 ARRIVE *=*+159 turn of arrival
1580 WORDS *=*+272 various words for messages
1590 CORPT *=*+159 codes for unit types
1600 CORPNO *=*+159 ID numbers of units
1610 HDIGIT *=*+256 tables for displaying numbers (hundreds)
1620 TDIGIT *=*+256 tens tables
1630 ODIGIT *=*+256 ones tables
1640 TXTTBL *=*+96 more text
1650 MONLEN *=*+13 table of month lengths
1660 HMORDS *=*+159 how many orders each unit has in queue
1670 WHORDS *=*+159 what the orders are
1680 WHORDH *=*+159
1690 BEEPTB *=*+4 table of beep tones
1700 ERRMSG *=*+128 table of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decodingle of error messages
1710 XOFF *=*+4 offsets for moving maltakreuze
1720 YOFF *=*+4
1730 MASKO *=*+4 mask values for decoding